Index: /XIOS/dev/dev_olga/bld.cfg
===================================================================
--- /XIOS/dev/dev_olga/bld.cfg	(revision 1020)
+++ /XIOS/dev/dev_olga/bld.cfg	(revision 1021)
@@ -35,5 +35,5 @@
 bld::target xios_server.exe 
 bld::target xios_server1.exe xios_server2.exe
-bld::target test_regular.exe
+#bld::target test_regular.exe
 #bld::target test_new_features.exe test_unstruct_complete.exe 
 #bld::target test_client.exe test_complete.exe
Index: /XIOS/dev/dev_olga/src/client.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/client.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/client.cpp	(revision 1021)
@@ -57,5 +57,6 @@
 
           unsigned long hashClient = hashString(codeId) ;
-          unsigned long hashServer = hashString(CXios::xiosCodeIdPrm);
+          unsigned long hashServer = hashString(CXios::xiosCodeId);
+//          unsigned long hashServer = hashString(CXios::xiosCodeIdPrm);
           unsigned long* hashAll ;
           int size ;
@@ -88,7 +89,7 @@
           for (i=0; i < size; ++i)
           {
-            if ((hashAll[i] == hashString(CXios::xiosCodeId))
-                || (hashAll[i] == hashString(CXios::xiosCodeIdPrm))
-                || (hashAll[i] == hashString(CXios::xiosCodeIdSnd)))
+            if (hashAll[i] == hashString(CXios::xiosCodeId))
+//                || (hashAll[i] == hashString(CXios::xiosCodeIdPrm))
+//                || (hashAll[i] == hashString(CXios::xiosCodeIdSnd)))
             {
               CXios::setUsingServer();
@@ -103,5 +104,4 @@
           {
             int clientLeader=leaders[hashClient] ;
-//            serverLeader=leaders[hashServer] ;
             serverLeader.push_back(leaders[hashServer]) ;
             int intraCommSize, intraCommRank ;
@@ -111,7 +111,4 @@
                    <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader.back()<<endl ;
              MPI_Intercomm_create(intraComm, 0, CXios::globalComm, serverLeader.back(), 0, &interComm) ;
-//             info(50)<<"intercommCreate::client "<<rank<<" intraCommSize : "<<intraCommSize
-//                    <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader<<endl ;
-//              MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
           }
           else
@@ -181,7 +178,8 @@
 /*!
  * \fn void CClient::registerContext(const string& id, MPI_Comm contextComm)
- * Function creates intraComm (CClient::intraComm) for client group with id=codeId and interComm (CClient::interComm) between client and server groups.
+ * \brief Sends a request to create a context to server. Creates client/server contexts.
  * \param [in] id id of context.
  * \param [in] contextComm.
+ * Function is only called by client.
  */
     void CClient::registerContext(const string& id, MPI_Comm contextComm)
@@ -250,12 +248,14 @@
     }
 
-    ///---------------------------------------------------------------
-    /*!
-     * \fn void CClient::registerContext(const string& id, const int poolNb, MPI_Comm contextComm)
-     * Function creates intraComm (CClient::intraComm) for client group with id=codeId and interComm (CClient::interComm) between client and server groups.
-     * \param [in] id id of context.
-     * \param [in] contextComm.
-     */
-        void CClient::registerContextOnSrvPools(const string& id, MPI_Comm contextComm)
+///---------------------------------------------------------------
+/*!
+  * \fn void CClient::registerContextByClienOfServer(const string& id, MPI_Comm contextComm)
+  * \brief Sends a request to create contexts on secondary servers. Creates clientPrimServer/serverPrimServer contexts.
+  * \param [in] id id of context.
+  * \param [in] contextComm.
+  * Function is called by primary server.
+  * The only difference with CClient::registerContext() is naming of contexts on servers (appearing of pool id at the end).
+  */
+        void CClient::registerContextByClienOfServer(const string& id, MPI_Comm contextComm)
         {
           CContext::setCurrent(id) ;
Index: /XIOS/dev/dev_olga/src/client.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/client.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/client.hpp	(revision 1021)
@@ -15,5 +15,5 @@
         static void finalize(void);
         static void registerContext(const string& id, MPI_Comm contextComm);
-        static void registerContextOnSrvPools(const string& id, MPI_Comm contextComm);
+        static void registerContextByClienOfServer(const string& id, MPI_Comm contextComm);
 
         static MPI_Comm intraComm;
Index: /XIOS/dev/dev_olga/src/config/field_attribute.conf
===================================================================
--- /XIOS/dev/dev_olga/src/config/field_attribute.conf	(revision 1020)
+++ /XIOS/dev/dev_olga/src/config/field_attribute.conf	(revision 1021)
@@ -11,4 +11,5 @@
 DECLARE_ATTRIBUTE(int,       level)
 DECLARE_ATTRIBUTE(int,       prec)
+DECLARE_ATTRIBUTE(StdString, expr)
 
 DECLARE_ATTRIBUTE(bool,      enabled)
@@ -33,2 +34,5 @@
 DECLARE_ATTRIBUTE(bool,      ts_enabled)
 DECLARE_ATTRIBUTE(CDuration, ts_split_freq)
+
+DECLARE_ATTRIBUTE(StdString, cell_methods)
+DECLARE_ENUM4(cell_methods_mode,  overwrite, prefix, suffix, none)
Index: /XIOS/dev/dev_olga/src/config/interpolate_domain_attribute.conf
===================================================================
--- /XIOS/dev/dev_olga/src/config/interpolate_domain_attribute.conf	(revision 1020)
+++ /XIOS/dev/dev_olga/src/config/interpolate_domain_attribute.conf	(revision 1021)
@@ -3,2 +3,7 @@
 DECLARE_ATTRIBUTE(int, order)
 DECLARE_ATTRIBUTE(bool, renormalize)
+
+/* Write interpolation weights into file */
+DECLARE_ENUM3(mode,compute,read,read_or_compute)
+DECLARE_ATTRIBUTE(StdString, weight_filename)
+DECLARE_ATTRIBUTE(bool, write_weight)
Index: /XIOS/dev/dev_olga/src/context_client.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/context_client.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/context_client.cpp	(revision 1021)
@@ -50,5 +50,6 @@
         for (int i = 0; i < serverByClient; i++)
           ranksServerLeader.push_back(rankStart + i);
-      }
+
+        ranksServerNotLeader.resize(0);      }
       else
       {
@@ -60,4 +61,6 @@
           if (clientRank % (clientByServer + 1) == 0)
             ranksServerLeader.push_back(clientRank / (clientByServer + 1));
+          else
+            ranksServerNotLeader.push_back(clientRank / (clientByServer + 1));
         }
         else
@@ -66,4 +69,6 @@
           if (rank % clientByServer == 0)
             ranksServerLeader.push_back(remain + rank / clientByServer);
+          else
+            ranksServerNotLeader.push_back(remain + rank / clientByServer);
         }
       }
@@ -244,4 +249,22 @@
                           + 1;                                   // the other local buffer might contain only one event
    }
+
+   /*!
+    Get leading server in the group of connected server
+    \return ranks of leading servers
+    */
+    const std::list<int>& CContextClient::getRanksServerNotLeader(void) const
+    {
+      return ranksServerNotLeader;
+    }
+
+    /*!
+    Check if client connects to leading server
+    \return connected(true), not connected (false)
+    */
+    bool CContextClient::isServerNotLeader(void) const
+    {
+      return !ranksServerNotLeader.empty();
+    }
 
   /*!
Index: /XIOS/dev/dev_olga/src/context_client.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/context_client.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/context_client.hpp	(revision 1021)
@@ -41,5 +41,7 @@
 
       bool isServerLeader(void) const;
+      bool isServerNotLeader(void) const;
       const std::list<int>& getRanksServerLeader(void) const;
+      const std::list<int>& getRanksServerNotLeader(void) const;
 
       bool isAttachedModeEnabled() const;
@@ -80,4 +82,7 @@
       std::list<int> ranksServerLeader;
 
+      //! List of server ranks for which the client is not leader
+      std::list<int> ranksServerNotLeader;
+
     public: // Some function should be removed in the future
       //    void registerEvent(CEventClient& event);
Index: /XIOS/dev/dev_olga/src/context_server.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/context_server.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/context_server.cpp	(revision 1021)
@@ -44,25 +44,25 @@
   }
 
-  CContextServer::CContextServer(CContext* parent, int srvLvl, MPI_Comm intraComm_,MPI_Comm interComm_)
-  {
-    context=parent;
-    intraComm=intraComm_;
-    MPI_Comm_size(intraComm,&intraCommSize);
-    MPI_Comm_rank(intraComm,&intraCommRank);
-    interComm=interComm_;
-    int flag;
-    MPI_Comm_test_inter(interComm,&flag);
-    if (flag) MPI_Comm_remote_size(interComm,&commSize);
-    else  MPI_Comm_size(interComm,&commSize);
-
-    currentTimeLine=0;
-    scheduled=false;
-    finished=false;
-
-    boost::hash<string> hashString;
-    StdString contextId = context->getId();
-    hashId=hashString(contextId);
-
-  }
+//  CContextServer::CContextServer(CContext* parent, int srvLvl, MPI_Comm intraComm_,MPI_Comm interComm_)
+//  {
+//    context=parent;
+//    intraComm=intraComm_;
+//    MPI_Comm_size(intraComm,&intraCommSize);
+//    MPI_Comm_rank(intraComm,&intraCommRank);
+//    interComm=interComm_;
+//    int flag;
+//    MPI_Comm_test_inter(interComm,&flag);
+//    if (flag) MPI_Comm_remote_size(interComm,&commSize);
+//    else  MPI_Comm_size(interComm,&commSize);
+//
+//    currentTimeLine=0;
+//    scheduled=false;
+//    finished=false;
+//
+//    boost::hash<string> hashString;
+//    StdString contextId = context->getId();
+//    hashId=hashString(contextId);
+//
+//  }
   void CContextServer::setPendingEvent(void)
   {
Index: /XIOS/dev/dev_olga/src/cxios.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/cxios.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/cxios.cpp	(revision 1021)
@@ -16,17 +16,19 @@
   string CXios::rootFile="./iodef.xml" ;
   string CXios::xiosCodeId="xios.x" ;
-  string CXios::xiosCodeIdPrm="xios.x.1" ;
-  string CXios::xiosCodeIdSnd="xios.x.2" ;
+//  string CXios::xiosCodeIdPrm="xios.x.1" ;
+//  string CXios::xiosCodeIdSnd="xios.x.2" ;
   string CXios::clientFile="./xios_client";
   string CXios::serverFile="./xios_server";
-  string CXios::serverPrimFile="./xios_server1";
-  string CXios::serverScndFile="./xios_server2";
+  string CXios::serverPrmFile="./xios_server1";
+  string CXios::serverSndFile="./xios_server2";
 
   bool CXios::isClient ;
   bool CXios::isServer ;
-  int CXios::serverLevel = 0 ;
+//  int CXios::serverLevel = 0 ;
   MPI_Comm CXios::globalComm ;
   bool CXios::usingOasis ;
   bool CXios::usingServer = false;
+  bool CXios::usingServer2 = false;
+  int CXios::ratioServer2 = 50;
   double CXios::bufferSizeFactor = 1.0;
   const double CXios::defaultBufferSizeFactor = 1.0;
@@ -52,4 +54,6 @@
     usingOasis=getin<bool>("using_oasis",false) ;
     usingServer=getin<bool>("using_server",false) ;
+    usingServer2=getin<bool>("using_server2",false) ;
+    ratioServer2=getin<int>("ratio_server2",50);
     info.setLevel(getin<int>("info_level",0)) ;
     report.setLevel(getin<int>("info_level",50));
@@ -135,32 +139,43 @@
   {
     initServer();
-    if (serverLvl == 1)
+
+//    if (serverLvl == 1)
+//      isClient = true;
+//    else
+//      isClient = false;
+//
+//    isServer = true;
+//    serverLevel = serverLvl;
+
+
+
+    // Initialize all aspects MPI
+    CServer::initialize();
+    isServer = true;
+    if (CServer::serverLevel == 1)
       isClient = true;
     else
       isClient = false;
 
-    isServer = true;
-    serverLevel = serverLvl;
-
-    // Initialize all aspects MPI
-    CServer::initialize();
     if (CServer::getRank()==0) globalRegistry = new CRegistry(CServer::intraComm) ;
     
     if (printLogs2Files)
     {
-      if (CXios::serverLevel == 0)
+      if (CServer::serverLevel == 0)
+//      if (CXios::serverLevel == 0)
       {
         CServer::openInfoStream(serverFile);
         CServer::openErrorStream(serverFile);
       }
-      else if (CXios::serverLevel == 1)
+      else if (CServer::serverLevel == 1)
+//      else if (CXios::serverLevel == 1)
       {
-        CServer::openInfoStream(serverPrimFile);
-        CServer::openErrorStream(serverPrimFile);
+        CServer::openInfoStream(serverPrmFile);
+        CServer::openErrorStream(serverPrmFile);
       }
       else
       {
-        CServer::openInfoStream(serverScndFile);
-        CServer::openErrorStream(serverScndFile);
+        CServer::openInfoStream(serverSndFile);
+        CServer::openErrorStream(serverSndFile);
       }
     }
@@ -197,10 +212,4 @@
   }
 
-  //! Set using secondary server
-//  void CXios::setUsingSecondaryServer()
-//  {
-//    usingSecondaryServer = true;
-//  }
-
   //! Unset using server
   void CXios::setNotUsingServer()
Index: /XIOS/dev/dev_olga/src/cxios.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/cxios.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/cxios.hpp	(revision 1021)
@@ -29,15 +29,15 @@
      static string rootFile ; //!< Configuration filename
      static string xiosCodeId ; //!< Identity for XIOS
-     static string xiosCodeIdPrm ; //!< Identity for XIOS primary server
-     static string xiosCodeIdSnd ; //!< Identity for XIOS secondary server
+//     static string xiosCodeIdPrm ; //!< Identity for XIOS primary server
+//     static string xiosCodeIdSnd ; //!< Identity for XIOS secondary server
      static string clientFile;        //!< Filename template for client
      static string serverFile;        //!< Filename template for server
-     static string serverPrimFile;  //!< Filename template for primary server in case of two server groups
-     static string serverScndFile;  //!< Filename template for secondary server in case of two server groups
+     static string serverPrmFile;  //!< Filename template for primary server in case of two server levels
+     static string serverSndFile;  //!< Filename template for secondary server in case of two server levels
 
      static bool isClient ; //!< Check if xios is client
      static bool isServer ; //!< Check if xios is server
 
-     static int serverLevel ; //
+//     static int serverLevel ;
 
      static MPI_Comm globalComm ; //!< Global communicator
@@ -46,4 +46,6 @@
      static bool usingOasis ; //!< Using Oasis
      static bool usingServer ; //!< Using server (server mode)
+     static bool usingServer2 ; //!< Using secondary server (server mode)
+     static int ratioServer2 ;  //!< Percentage of server processors dedicated to secondary server
      static double bufferSizeFactor; //!< Factor used to tune the buffer size
      static const double defaultBufferSizeFactor; //!< Default factor value
@@ -55,7 +57,4 @@
      //! Setting xios to use server mode
      static void setUsingServer();
-
-     //! Setting xios to use secondary server mode
-//     static void setUsingSecondaryServer();
 
      //! Setting xios NOT to use server mode
Index: /XIOS/dev/dev_olga/src/distribution_client.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/distribution_client.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/distribution_client.cpp	(revision 1021)
@@ -24,5 +24,4 @@
    , elementZoomMask_(), elementNLocal_(), elementNGlobal_()
 {
-//  numElement_ = globalLocalIndex.size();    !!! numElement_ should be calculated (?)
   isComputed_ = true;
   localDataIndex_.resize(globalLocalIndex.size());
Index: /XIOS/dev/dev_olga/src/filter/filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/filter.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/filter.cpp	(revision 1021)
@@ -5,5 +5,5 @@
   CFilter::CFilter(CGarbageCollector& gc, size_t inputSlotsCount, IFilterEngine* engine)
     : CInputPin(gc, inputSlotsCount)
-    , COutputPin()
+    , COutputPin(gc)
     , engine(engine)
     , inputSlotCount(inputSlotCount)
@@ -14,5 +14,29 @@
     CDataPacketPtr outputPacket = engine->apply(data);
     if (outputPacket)
-      deliverOuput(outputPacket);
+      onOutputReady(outputPacket);
+  }
+
+  void CFilter::setInputTrigger(size_t inputSlot, COutputPin* trigger)
+  {
+    // Was the filter already triggerable? If not, we need to inform
+    // all downstream filters.
+    bool wasTriggerable = canBeTriggered();
+
+    CInputPin::setInputTrigger(inputSlot, trigger);
+
+    if (!wasTriggerable)
+      setOutputTriggers();
+  }
+
+  void CFilter::trigger(Time timestamp)
+  {
+    CInputPin::trigger(timestamp);
+
+    COutputPin::trigger(timestamp);
+  }
+
+  bool CFilter::canBeTriggered() const
+  {
+    return (CInputPin::canBeTriggered() || COutputPin::canBeTriggered());
   }
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/filter.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/filter.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/filter.hpp	(revision 1021)
@@ -26,4 +26,26 @@
       CFilter(CGarbageCollector& gc, size_t inputSlotsCount, IFilterEngine* engine);
 
+      /*!
+       * Sets the trigger for a specific input slot.
+       *
+       * \param inputSlot the input slot number
+       * \param trigger the corresponding trigger
+       */
+      void virtual setInputTrigger(size_t inputSlot, COutputPin* trigger);
+
+      /*!
+       * Triggers the filter for the specified timestamp.
+       *
+       * \param timestamp the timestamp for which we are triggering the filter
+       */
+      void virtual trigger(Time timestamp);
+
+      /*!
+       * Tests if the filter can be triggered.
+       *
+       * \return true if the filter can be triggered
+       */
+      bool virtual canBeTriggered() const;
+
     protected:
       IFilterEngine* engine; //!< The filter engine, might be the filter itself
Index: /XIOS/dev/dev_olga/src/filter/garbage_collector.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/garbage_collector.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/garbage_collector.cpp	(revision 1021)
@@ -3,28 +3,28 @@
 namespace xios
 {
-  void CGarbageCollector::registerFilter(CInputPin* inputPin, Time timestamp)
+  void CGarbageCollector::registerObject(InvalidableObject* Object, Time timestamp)
   {
-    registeredFilters[timestamp].insert(inputPin);
+    registeredObjects[timestamp].insert(Object);
   }
 
-  void CGarbageCollector::unregisterFilter(CInputPin* inputPin, Time timestamp)
+  void CGarbageCollector::unregisterObject(InvalidableObject* Object, Time timestamp)
   {
-    std::map<Time, std::set<CInputPin*> >::iterator it = registeredFilters.find(timestamp);
-    if (it != registeredFilters.end())
-      it->second.erase(inputPin);
+    std::map<Time, std::set<InvalidableObject*> >::iterator it = registeredObjects.find(timestamp);
+    if (it != registeredObjects.end())
+      it->second.erase(Object);
   }
 
   void CGarbageCollector::invalidate(Time timestamp)
   {
-    std::map<Time, std::set<CInputPin*> >::iterator it    = registeredFilters.begin(),
-                                                    itEnd = registeredFilters.lower_bound(timestamp);
+    std::map<Time, std::set<InvalidableObject*> >::iterator it    = registeredObjects.begin(),
+                                                            itEnd = registeredObjects.lower_bound(timestamp);
     for (; it != itEnd; ++it)
     {
-      std::set<CInputPin*>::iterator itFilter    = it->second.begin(),
-                                     itFilterEnd = it->second.end();
-      for (; itFilter != itFilterEnd; ++itFilter)
-        (*itFilter)->invalidate(timestamp);
+      std::set<InvalidableObject*>::iterator itObject    = it->second.begin(),
+                                             itObjectEnd = it->second.end();
+      for (; itObject != itObjectEnd; ++itObject)
+        (*itObject)->invalidate(timestamp);
     }
-    registeredFilters.erase(registeredFilters.begin(), itEnd);
+    registeredObjects.erase(registeredObjects.begin(), itEnd);
   }
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/garbage_collector.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/garbage_collector.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/garbage_collector.hpp	(revision 1021)
@@ -5,8 +5,21 @@
 #include <set>
 
-#include "input_pin.hpp"
+#include "date.hpp"
 
 namespace xios
 {
+  /*!
+   * Interface shared by all objects that might need to invalidate packets.
+   */
+  struct InvalidableObject
+  {
+    /*!
+     * Removes all pending packets which are older than the specified timestamp.
+     *
+     * \param timestamp the timestamp used for invalidation
+     */
+    void virtual invalidate(Time timestamp) = 0;
+  }; // struct InvalidableObject
+
   /*!
    * A basic garbage collector which ensures no old packets linger in the filter graph.
@@ -22,21 +35,21 @@
 
       /*!
-       * Registers a filter for a specified timestamp.
+       * Registers an object for a specified timestamp.
        *
-       * \param inputPin the input pin of the filter to register
-       * \param timestamp the timestamp for which the filter is registered
+       * \param object the object to register
+       * \param timestamp the timestamp for which the object is registered
        */
-      void registerFilter(CInputPin* inputPin, Time timestamp);
+      void registerObject(InvalidableObject* object, Time timestamp);
 
       /*!
-       * Removes a filter previously registered for a specified timestamp.
+       * Removes a object previously registered for a specified timestamp.
        *
-       * \param inputPin the input pin of the filter to unregister
-       * \param timestamp the timestamp for which the filter is unregistered
+       * \param object the object to unregister
+       * \param timestamp the timestamp for which the object is unregistered
        */
-      void unregisterFilter(CInputPin* inputPin, Time timestamp);
+      void unregisterObject(InvalidableObject* object, Time timestamp);
 
       /*!
-       * Ensures all registered filters invalidate packets older than the specified timestamp.
+       * Ensures all registered objects invalidate packets older than the specified timestamp.
        *
        * \param timestamp the timestamp used for invalidation
@@ -48,5 +61,5 @@
       CGarbageCollector& operator=(const CGarbageCollector&);
 
-      std::map<Time, std::set<CInputPin*> > registeredFilters; //!< Currently registered filters
+      std::map<Time, std::set<InvalidableObject*> > registeredObjects; //!< Currently registered objects
   }; // class CGarbageCollector
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/input_pin.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/input_pin.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/input_pin.cpp	(revision 1021)
@@ -1,3 +1,4 @@
 #include "input_pin.hpp"
+#include "output_pin.hpp"
 #include "garbage_collector.hpp"
 #include "exception.hpp"
@@ -8,4 +9,6 @@
     : gc(gc)
     , slotsCount(slotsCount)
+    , triggers(slotsCount)
+    , hasTriggers(false)
   { /* Nothing to do */ }
 
@@ -23,5 +26,5 @@
     {
       it = inputs.insert(std::make_pair(packet->timestamp, InputBuffer(slotsCount))).first;
-      gc.registerFilter(this, packet->timestamp);
+      gc.registerObject(this, packet->timestamp);
     }
     it->second.slotsFilled++;
@@ -31,8 +34,41 @@
     {
       // Unregister before calling onInputReady in case the filter registers again
-      gc.unregisterFilter(this, packet->timestamp);
+      gc.unregisterObject(this, packet->timestamp);
       onInputReady(it->second.packets);
       inputs.erase(it);
     }
+  }
+
+  void CInputPin::setInputTrigger(size_t inputSlot, COutputPin* trigger)
+  {
+    if (inputSlot >= slotsCount)
+      ERROR("void CInputPin::setInputTrigger(size_t inputSlot, COutputPin* trigger)",
+            "The input slot " << inputSlot << " does not exist.");
+    if (triggers[inputSlot])
+      ERROR("void CInputPin::setInputTrigger(size_t inputSlot, COutputPin* trigger)",
+            "The trigger for input slot " << inputSlot << " has already been set.");
+
+    triggers[inputSlot] = trigger;
+    hasTriggers = true;
+  }
+
+  void CInputPin::trigger(Time timestamp)
+  {
+    if (hasTriggers) // Don't use canBeTriggered here, this function is virtual and can be overriden
+    {
+      std::map<Time, InputBuffer>::iterator it = inputs.find(timestamp);
+      bool nothingReceived = (it == inputs.end());
+
+      for (size_t s = 0; s < slotsCount; s++)
+      {
+        if (triggers[s] && (nothingReceived || !it->second.packets[s]))
+          triggers[s]->trigger(timestamp);
+      }
+    }
+  }
+
+  bool CInputPin::canBeTriggered() const
+  {
+    return hasTriggers;
   }
 
Index: /XIOS/dev/dev_olga/src/filter/input_pin.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/input_pin.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/input_pin.hpp	(revision 1021)
@@ -5,14 +5,15 @@
 #include <map>
 
+#include "garbage_collector.hpp"
 #include "data_packet.hpp"
 
 namespace xios
 {
-  class CGarbageCollector;
+  class COutputPin;
 
   /*!
    * An input pin handles the data packets received by a filter.
    */
-  class CInputPin
+  class CInputPin : public InvalidableObject
   {
     public:
@@ -27,4 +28,12 @@
 
       /*!
+       * Sets the trigger for a specific input slot.
+       *
+       * \param inputSlot the input slot number
+       * \param trigger the corresponding trigger
+       */
+      void virtual setInputTrigger(size_t inputSlot, COutputPin* trigger);
+
+      /*!
        * Receives a data packet from an upstream filter on
        * the specified input slot.
@@ -37,4 +46,18 @@
 
       /*!
+       * Triggers the input of any buffered packet for the specified timestamp.
+       *
+       * \param timestamp the timestamp for which we are triggering the input
+       */
+      void virtual trigger(Time timestamp);
+
+      /*!
+       * Tests if the pin can be triggered.
+       *
+       * \return true if the pin can be triggered
+       */
+      bool virtual canBeTriggered() const;
+
+      /*!
        * Removes all pending packets which are older than the specified timestamp.
        *
@@ -44,6 +67,4 @@
 
     protected:
-      CGarbageCollector& gc; //!< The garbage collector associated to the input pin
-
       /*!
        * Function triggered when all slots have been filled for a specific timestamp.
@@ -75,8 +96,16 @@
       };
 
+      CGarbageCollector& gc; //!< The garbage collector associated to the input pin
+
       size_t slotsCount; //!< The number of slots
 
       //! Input buffer, store the packets until all slots are full for a timestep
       std::map<Time, InputBuffer> inputs;
+
+      //! Store the triggers corresponding to the input slots
+      std::vector<COutputPin*> triggers;
+
+      //! Whether some triggers have been set
+      bool hasTriggers;
   }; // class CInputPin
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/filter/output_pin.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/output_pin.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/filter/output_pin.cpp	(revision 1021)
@@ -4,4 +4,9 @@
 namespace xios
 {
+  COutputPin::COutputPin(CGarbageCollector& gc, bool manualTrigger /*= false*/)
+    : gc(gc)
+    , manualTrigger(manualTrigger)
+  { /* Nothing to do */ }
+
   void COutputPin::connectOutput(boost::shared_ptr<CInputPin> inputPin, size_t inputSlot)
   {
@@ -11,4 +16,22 @@
 
     outputs.push_back(std::make_pair(inputPin, inputSlot));
+
+    if (canBeTriggered())
+      inputPin->setInputTrigger(inputSlot, this);
+  }
+
+  void COutputPin::onOutputReady(CDataPacketPtr packet)
+  {
+    if (!packet)
+      ERROR("void COutputPin::onOutputReady(CDataPacketPtr packet)",
+            "The packet cannot be null.");
+
+    if (manualTrigger) // Don't use canBeTriggered here, this function is virtual and can be overriden
+    {
+      outputPackets[packet->timestamp] = packet;
+      gc.registerObject(this, packet->timestamp);
+    }
+    else
+      deliverOuput(packet);
   }
 
@@ -23,3 +46,34 @@
       it->first->setInput(it->second, packet);
   }
+
+  void COutputPin::trigger(Time timestamp)
+  {
+    if (manualTrigger) // Don't use canBeTriggered here, this function is virtual and can be overriden
+    {
+      std::map<Time, CDataPacketPtr>::iterator it = outputPackets.find(timestamp);
+      if (it != outputPackets.end())
+      {
+        gc.unregisterObject(this, timestamp);
+        deliverOuput(it->second);
+        outputPackets.erase(it);
+      }
+    }
+  }
+
+  bool COutputPin::canBeTriggered() const
+  {
+    return manualTrigger;
+  }
+
+  void COutputPin::setOutputTriggers()
+  {
+    std::vector<std::pair<boost::shared_ptr<CInputPin>, size_t> >::iterator it, itEnd;
+    for (it = outputs.begin(), itEnd = outputs.end(); it != itEnd; ++it)
+      it->first->setInputTrigger(it->second, this);
+  }
+
+  void COutputPin::invalidate(Time timestamp)
+  {
+    outputPackets.erase(outputPackets.begin(), outputPackets.lower_bound(timestamp));
+  }
 } // namespace xios
